;;; "ga-summe-15.scm"
(load "breakpoint.scm")
; sucht -  allein mit GA - drei Zahlen zwischen 1 und 15,
; deren Summe 15 ergeben soll.
;;; ===== Zahlen beschaffen =====
(define
  *zahlen*
  '(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15))
  ;(let rekursion ((n 15)) (cond ((zero? n)'()) (else (cons n (rekursion (sub1 n)))))))
;*zahlen*

;;; ===== Pool erzeugen =====
; Hilfsfunktion fuer pool
(define
  (split zahlen an von)
  (append
   (list-tail zahlen an)
   (list-tail (reverse zahlen) (- von an))))
;;; ----- Pool -----
(define
  *pool*
  (let rekursion
    ((n 50)
     (zahlen *zahlen*)
     (anzahl (length *zahlen*)))
    (cond
      ((zero? n)'())
      (else
       (cons
        (split zahlen (random anzahl) anzahl)
        (rekursion (sub1 n) zahlen anzahl))))))
;*pool*

;;; ===== GA =====
;;; ----- bewerte -----
; bewertet die Loesung mit quadratischer Abweichung
; vom Sollwert
(define
  (bewerte zahlen)
  (sqr (- 15 (car zahlen) (cadr zahlen) (caddr zahlen))))

;;; ----- selektiere -----
; selektiert die anzahl Elemente aus dem pool durch zufaellige
; Auswahl von Paaren.
(define
  (selektiere anzahl pool akku)
  (cond
    ((= anzahl (length akku)) akku)
    (else
     (selektiere
      (sub1 anzahl)
      pool
      (cons
       (bester-von
        (list-ref pool (random (length pool)))
        (list-ref pool (random (length pool))))
       akku)))))
; ----- bester-von -----
; Hilfsfunktion fuer selektiere
; bestimmt von zwei Listen die mit der besten Bewertung
(define
  (bester-von erster zweiter)
  (if (< (bewerte erster) (bewerte zweiter)) erster zweiter))

;;; ----- mutiere -----
; die mutiere - Funktion splittet mehrfach nacheinander neu
(define
  (mutiere individuum anzahl)
  (cond
    ((negative? anzahl) individuum)
    (else
     (mutiere
      (split
       individuum
       (random (length individuum))
       (length individuum))
      (sub1 anzahl)))))
  
;;; ----- generation -----
; wendet zunaechst auf jedes Poolelement die Mutation an
; und selektiert dann wieder auf Poolgroesse.
(define
  (generation pool akku)
  (cond
    ((null? pool) akku)
    (else
     (generation
      (cdr pool) 
      (cons
       (car pool)
       (cons
        (mutiere (car pool) 4)
        akku))))))

;;; ----- generationen-folge -----
; Der Gedanke bei der Generationenfolge war zunaechst abzubrechen,
; wenn die erste Loesung gefunden wurde. Das ist bei der gewaehlten
; Konstruktionsfunktion aber unsinnig, da im Pool schon eine Loesung
; enthalten ist. Daher werden aus dem Pool alle Loesungen angezeigt.
(define
  (generationen-folge pool n)
  (cond
    ((zero? n) (zeige-Loesungen pool))
    (else
     (display n)(newline)
     (generationen-folge (generation pool `()) (sub1 n)))))
; Hilfsfunktion zum Filtern von Loesungen:
(define
  (zeige-Loesungen pool)
  (cond
    ((null? pool) '())
    ((zero? (bewerte (car pool)))
     (ohne-wiederholung (car pool) (zeige-Loesungen (cdr pool))))
    (else  (zeige-Loesungen (cdr pool)))))
; Hilfsfunktion, die Mehrfachloesungen unterdrueckt
(define
  (ohne-wiederholung individuum liste)
  (if
   (vorhanden? individuum liste)
   liste
   (cons individuum liste)))
(define
  (vorhanden? individuum liste)
  (cond
    ((null? liste) #f)
    ((gleich? (erste-drei individuum) (erste-drei (car liste))) #t)
    (else (vorhanden? individuum (cdr liste)))))
(define
  (erste-drei liste)
  (reverse (list-tail (reverse liste) (- (length liste) 3))))
(define
  (gleich? l-1 l-2)
  (cond
    ((null? l-1) #t)
    ((member (car l-1) l-2) (gleich? (cdr l-1) l-2))
    (else #f)))
    
(map erste-drei (generationen-folge *pool* 10))